;; MSX View ROM vO
;; 2020/11/9  HRA!
;; ------------------------------------------

		include		"MSXBIOS.ASM"
		include		"MSXDOS1.ASM"
		include		"MSXDOS2.ASM"

		org			0x100
entry::
		ld			sp, [TPA_BOTTOM]

check_slot1::
		ld			a, [exptbl + 1]		; slot#1
		and			a, 0x80
		jp			z, not_expanded_of_slot1

expanded_of_slot1:
		ld			b, 4
		ld			a, 0x81
slot1_loop:
		ld			c, a
		push		bc
		call		check_slot
		pop			bc
		jp			nc, exit_process
		ld			a, c
		add			a, 4
		djnz		slot1_loop
		jp			check_slot2

not_expanded_of_slot1:
		ld			a, 0x01
		call		check_slot
		jp			nc, exit_process

check_slot2::
		ld			a, [exptbl + 2]		; slot#2
		and			a, 0x80
		jp			z, not_expanded_of_slot2

expanded_of_slot2:
		ld			b, 4
		ld			a, 0x82
slot2_loop:
		ld			c, a
		push		bc
		call		check_slot
		pop			bc
		jp			nc, exit_process
		ld			a, c
		add			a, 4
		djnz		slot2_loop
		jp			not_found

not_expanded_of_slot2:
		ld			a, 0x02
		call		check_slot
		jp			nc, exit_process

not_found::
		xor			a, a
		ld			[slot_no], a

exit_process::
		ld			hl, 0x8000
		ld			a, [ramad2]
		call		enaslt

		ei

		ld			de, mes_slot
		ld			c, 9
		call		bdos
		
		ld			a, [slot_no]
		push		af
		rrca
		rrca
		rrca
		rrca
		and			a, 0x0F
		add			a, '0'
		cp			a, '9'
		jp			c, skip1
		add			a, 'A' - '0' - 10
skip1:
		ld			c, 6
		ld			e, a
		call		bdos
		pop			af

		and			a, 0x0F
		add			a, '0'
		cp			a, '9'
		jp			c, skip2
		add			a, 'A' - '0' - 10
skip2:
		ld			c, 6
		ld			e, a
		call		bdos

		ld			c, 6
		ld			e, '\n'
		call		bdos

		ld			c, 6
		ld			e, '\r'
		call		bdos

		ld			b, 0
		ld			c, D2F_TERM
		jp			bdos

; ----------------------------------------------
;  Slot #A  ViewROM hĂ邩ׂ
;  hĂ Cy = 0, hĂȂ Cy = 1
; ----------------------------------------------
check_slot::
		ld			hl, 0x8000
		ld			[slot_no], a
		call		enaslt

		ld			b, 11
		ld			hl, s_view_signature
		ld			de, 0x8010
check_loop::
		ld			a, [de]
		cp			a, [hl]
		jp			nz, no_match
		inc			hl
		inc			de
		djnz		check_loop
		or			a, a
		ret

no_match::
		scf
		ret

mes_slot:
		ds			"SLOT #$"
slot_no:
		db			0
s_view_signature::
		ds			"MSXViewKROM"
end_of_program::
